<?php
// Own namespace
namespace CoreFramework\Iterator\Registry;

// Import framework stuff
use CoreFramework\Iterator\BaseIterator;
use CoreFramework\Registry\Register;

// Import SPL stuff
use \Iterator;

/**
 * A Registry iterator
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2017 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class RegistryIterator extends BaseIterator implements Iterator {
	/**
	 * Protected constructor
	 *
	 * @return	void
	 */
	protected function __construct () {
		// Call parent constructor
		parent::__construct(__CLASS__);
	}

	/**
	 * Creates an instance of this class
	 *
	 * @param	$registryInstance	An instance of a Register class
	 * @return	$iteratorInstance	An instance of a Iterator class
	 */
	public final static function createRegistryIterator (Register $registryInstance) {
		// Get new instance
		$iteratorInstance = new RegistryIterator();

		// Set registry here
		$iteratorInstance->setRegistryInstance($registryInstance);

		// Return the prepared instance
		return $iteratorInstance;
	}

	/**
	 * Getter for current value from group or generic
	 *
	 * @return	$current	Current value in iteration
	 */
	public function current () {
		// Default is null
		$current = null;

		$this->partialStub('Please implement this method.');

		// Return it
		return $current;
	}

	/**
	 * Getter for key from group or generic
	 *
	 * @return	$key	Current key in iteration
	 */
	public function key () {
		// Default is null
		$key = null;

		$this->partialStub('Please implement this method.');

		// Return it
		return $key;
	}

	/**
	 * Advances to the next entry
	 *
	 * @return	void
	 */
	public function next () {
		$this->partialStub('Please implement this method.');
	}

	/**
	 * Rewinds to the beginning of the iteration
	 *
	 * @return	void
	 */
	public function rewind () {
		$this->partialStub('Please implement this method.');
	}

	/**
	 * Checks wether the current entry is valid (not at the end of the list)
	 *
	 * @return	void
	 */
	public function valid () {
		$this->partialStub('Please implement this method.');
	}

}
